VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTextCompare"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'---------------------------------------------------------------------------------------
' Module    : cTextCompare
' DateTime  : 23.07.2005 18:35
' Author    : Philipp S
' Purpose   : Klasse zum vergleichen von Texten
' Copyright : 2005 by Philipp S
'---------------------------------------------------------------------------------------

' ---=== Beschreibung ===---
'Fehlerwertverhalten:
'Diesen Eigenschaften kann man einen Wert geben wie ein Fehler bewertet
'werden soll, 0 fr nicht Zhlen und 1 fr ganzen Fehler.
'Es werden auch Kommawerte wie 0.5, 1/3 usw. akzeptiert
'WrongPosition: Wort steht an der falschen Position --  Test - Tset
'WrongLenght:   Buchstabe fehlt                     --  Test - Tes
'WrongChar:     Falscher Buchstabe                  --  Test - Twst

'berprfungsverhalten
'CaseSensitive: Gro-Kleinschreibung nicht beachten --  Test - test
'Intelligent:   Wenn Buchstaben an der falschen
'               Position stehen wird die Suchposition
'               korigiert                           --  Test - Tet
'

'SearchStart: Suche startet
'-Word:   Orginalwort
'-Search: Wort nach dem gesucht wird
'SearchEnd: Suche beendet
'-Lenght:   Lnge des Worts
'-Errors:  Anzahl der Fehler
'-Percent: Prozent was richtig ist
'ErrorWrongChar: Falscher Buchstabe
'-Position: momentane Position
'ErrorWrongPosition: Buchstabe an falscher Position
'-Position: momentane Position
'ErrorWrongLenght: Wort zu kurz
'-Position: momentane Position

' ---=== Variablen ===---
Dim mvarWrongPosition As Double
Dim mvarWrongLenght As Double
Dim mvarWrongChar As Double
Dim mvarCaseSensitive As Boolean
Dim mvarIntelligent As Boolean


' ---=== Events ===---
Event SearchStart(Word As String, Search As String)
Event SearchEnd(Lenght As Long, Errors As Long, Percent As Double)
Event ErrorWrongChar(Position As Long)
Event ErrorWrongPosition(Position As Long)
Event ErrorWrongLenght(Position As Long)


'---------------------------------------------------------------------------------------
' Procedure : Intelligent
' DateTime  : 19.12.2005 18:40
' Author    : Philipp S
' Purpose   : Legt fest ob die Wrter intelligent vergleicht werden sollen
'             Automatische Positionkorrektur
'---------------------------------------------------------------------------------------
'
Public Property Let Intelligent(ByVal vData As Boolean)
   mvarIntelligent = vData
End Property
Public Property Get Intelligent() As Boolean
   Intelligent = mvarIntelligent
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaseSensitive
' DateTime  : 19.12.2005 18:41
' Author    : Philipp S
' Purpose   : Legt fest ob gro/kleinschreibung beachtet werden soll
'---------------------------------------------------------------------------------------
'
Public Property Let CaseSensitive(ByVal vData As Boolean)
   mvarCaseSensitive = vData
End Property
Public Property Get CaseSensitive() As Boolean
   CaseSensitive = mvarCaseSensitive
End Property

'---------------------------------------------------------------------------------------
' Procedure : WrongChar
' DateTime  : 19.12.2005 18:41
' Author    : Philipp S
' Purpose   : Legt fest wie stark falsche Buchstaben gewertet werden sollen
'---------------------------------------------------------------------------------------
'
Public Property Let WrongChar(ByVal vData As Double)
   If vData <= 1 Then
      mvarWrongChar = vData
   End If
End Property
Public Property Get WrongChar() As Double
   WrongChar = mvarWrongChar
End Property

'---------------------------------------------------------------------------------------
' Procedure : WrongLenght
' DateTime  : 19.12.2005 18:43
' Author    : Philipp S
' Purpose   : Legt fest wie stark fehlende Buchstaben am Ende des Wort
'             gewertet werden sollen
'---------------------------------------------------------------------------------------
'
Public Property Let WrongLenght(ByVal vData As Double)
   If vData <= 1 Then
      mvarWrongLenght = vData
   End If
End Property
Public Property Get WrongLenght() As Double
   WrongLenght = mvarWrongLenght
End Property

'---------------------------------------------------------------------------------------
' Procedure : WrongPosition
' DateTime  : 19.12.2005 18:44
' Author    : Philipp S
' Purpose   : Legt fest wie stark Buchstaben an der falschen Position
'             gewertet werden sollen
'---------------------------------------------------------------------------------------
'
Public Property Let WrongPosition(ByVal vData As Double)
   If vData <= 1 Then
      mvarWrongPosition = vData
   End If
End Property
Public Property Get WrongPosition() As Double
   WrongPosition = mvarWrongPosition
End Property

'---------------------------------------------------------------------------------------
' Procedure : CompareText
' DateTime  : 23.07.2005 18:31
' Author    : Philipp S
' Purpose   : Vergleicht zwei Strings
'             Wie viel Prozent der zwei Wrter bereinstimmen wird
'             wird zurckgegeben
'---------------------------------------------------------------------------------------
'
Function CompareText(String1 As String, String2 As String) As Double
   Dim I          As Long, J As Long
   Dim lenString1 As Long
   Dim lenString2 As Long
   Dim Errors     As Double
   Dim Count      As Long
           
   On Error GoTo CompareText_Error
   
   'Lnge der Wrter speichern
   lenString1 = Len(String1)
   lenString2 = Len(String2)
   
   RaiseEvent SearchStart(String1, String2) 'SearchStart Event auslsen
   
   'Wenn Gro/Kleinschreibung nicht bewertet wird beide Wrter klein
   'speichern
   If CaseSensitive = False Then
      String1 = LCase(String1)
      String2 = LCase(String2)
   End If
   
   'String1 komplett durchlaufen
   For I = 1 To lenString1
      'Buchstaben an Position I Stimmen nicht berein
      If Mid(String1, I, 1) <> Mid(String2, I + J, 1) Then
         If I > 1 Then
            'Auch das vorherige Zeichen stimmt nicht
            If Mid(String1, I, 1) <> Mid(String2, I + J - 1, 1) Then
               If I < lenString2 Then
                  'Wenn das nchste Zeichen stimmt das WrongPosition
                  'Event auslsen und gegebenenfals die Position von J
                  'korrigieren
                  If Mid(String1, I, 1) <> Mid(String2, I + J + 1, 1) Then
                     Errors = Errors + WrongChar
                     RaiseEvent ErrorWrongChar(I)
                  Else
                     Errors = Errors + mvarWrongPosition
                     RaiseEvent ErrorWrongPosition(I)
                     If mvarIntelligent Then
                        J = J + 1
                     End If
                  End If
               Else
                  'Wenn das Wort ist zu kurz ist WrongLenght Event auslsen
                  'sonst das WrongChar Event auslsen
                  If lenString2 < I Then
                     Errors = Errors + mvarWrongLenght
                     RaiseEvent ErrorWrongLenght(I)
                  Else
                     Errors = Errors + WrongChar
                     RaiseEvent ErrorWrongChar(I)
                  End If
               End If
            Else
               'Das Zeichen befindet sich an der Falschen stelle. Falls
               'intelligent gesucht wird die Position von J korrigieren
               Errors = Errors + mvarWrongPosition
               RaiseEvent ErrorWrongPosition(I)
               If mvarIntelligent Then
                  J = J - 1
               End If
            End If
         Else
            'Falls I krzer als das zweiten Wort ist berprfen ob das
            'nchste Zeichen mit bereinstimmt. Falls intelligent gesucht
            'wird, wird der suchzeiger wieder ums eins korrigiert.
            'Sonst ein Errorevent auslsen
            If I < lenString2 Then
               If Mid(String1, I, 1) <> Mid(String2, I + J + 1, 1) Then
                  Errors = Errors + WrongChar
                  RaiseEvent ErrorWrongChar(I)
               Else
                  Errors = Errors + mvarWrongPosition
                  RaiseEvent ErrorWrongPosition(I)
                  If mvarIntelligent Then
                     J = J + 1
                  End If
               End If
            Else
               If lenString2 < I Then
                  Errors = Errors + mvarWrongLenght
                  RaiseEvent ErrorWrongLenght(I)
               Else
                  Errors = Errors + WrongChar
                  RaiseEvent ErrorWrongChar(I)
               End If
            End If
         End If
      End If
      'Count um eins erhhen
      Count = Count + 1
   Next
   'Wenn die lnge der beiden Wrter nicht bereinstimmt die Anzahl
   'an Errors und den Count erhhen
   If lenString1 <> lenString2 Then
      If lenString1 < lenString2 Then
         Errors = Errors + (lenString2 - lenString1) * mvarWrongLenght
         Count = Count + (lenString2 - lenString1) - 1
      End If
   End If
   
   'Prozentzahl ausrechnen und zurckgeben
   CompareText = 100 - 100 / Count * Errors
   RaiseEvent SearchEnd(Count, CLng(Errors), 100 - 100 / Count * Errors)

   On Error GoTo 0
   Exit Function

CompareText_Error:

   MsgBox "Error " & Err.Number & ":" & vbCrLf _
      & Err.Description & ") in procedure CompareText of Klassenmodul cTextCompare", _
      vbExclamation

End Function

'---------------------------------------------------------------------------------------
' Procedure : Class_Initialize
' DateTime  : 19.12.2005 19:03
' Author    : Philipp S
' Purpose   : Klasse Initialisieren
'---------------------------------------------------------------------------------------
'
Private Sub Class_Initialize()
   mvarWrongPosition = 0.5
   mvarWrongLenght = 0.5
   mvarWrongChar = 1
End Sub
